<template>
    <div class="modal" :class="{ active: isActiveModal }">
        <div
            @click="closeModal"
            class="bg-overolay fixed top-0 left-0 w-full h-full"
        ></div>
        <div class="modal-content bg-white rounded-md">
            <div
                class="modal-header font-semibold px-5 py-3 bg-gray-100 rounded-t-md"
            >
                <slot name="header"></slot>
                <div
                    @click="closeModal"
                    class="absolute -top-2 -right-2 w-9 h-9 bg-white rounded-md shadow-sm"
                >
                    <button v-tooltip:bottom="'Đóng'" class="w-9 h-9">
                        <XIcon class="h-6 w-9" />
                    </button>
                </div>
            </div>
            <div class="modal-body p-5">
                <slot name="body"></slot>
            </div>
            <div
                class="modal-footer flex items-center justify-end gap-2 px-5 py-3 border-t"
            >
                <slot name="btnSave"></slot>
                <BasicButton
                    @click="closeModal"
                    classCustom="bg-color-danger hover:shadow-hover-danger"
                >
                    Hủy
                </BasicButton>
            </div>
        </div>
    </div>
</template>

<script>
import { XIcon } from "@heroicons/vue/outline";
import BasicButton from "@/components/button/BasicButton.vue";

export default {
    components: {
        XIcon,
        BasicButton
    },
    props: {
        isActiveModal: {
            type: Boolean,
            default: false
        }
    },
    setup(_, context) {
        function closeModal() {
            context.emit("update:isActiveModal", false);
        }

        return {
            closeModal
        };
    }
};
</script>

<style lang="scss" scoped>
.modal {
    &.active {
        top: 0;
        .bg-overolay {
            opacity: 1;
            z-index: 9999;
        }
        .modal-content {
            top: 30px;
            opacity: 1;
            z-index: 99999;
        }
    }
    .bg-overolay {
        background: rgba(0, 0, 0, 0.4);
        opacity: 0;
        transition: all 0.3s ease-in-out;
        z-index: -1;
    }
    .modal-content {
        position: fixed;
        top: 0px;
        left: 50%;
        transform: translateX(-50%);
        width: 500px;
        opacity: 0;
        transition: all 0.3s ease-in-out;
        z-index: -1;
    }
}
</style>
